diff --git a/gcc/analyzer/engine.cc b/gcc/analyzer/engine.cc
index 9d22950d79b..14737295831 100644
--- a/gcc/analyzer/engine.cc
+++ b/gcc/analyzer/engine.cc
@@ -4412,407 +3664,122 @@ exploded_graph::process_node (exploded_node *node)
       logger->end_log_line ();
     }
 
-  switch (point.get_kind ())
-    {
-    default:
-      gcc_unreachable ();
-    case PK_ORIGIN:
-      /* This node exists to simplify finding the shortest path
-	 to an exploded_node.  */
-      break;
-
-    case PK_BEFORE_SUPERNODE:
-      {
-	program_state next_state (state);
-	uncertainty_t uncertainty;
+  /* Don't do anything for the origin enode; the initial population of the
+     worklist has already added successor enodes.  */
+  if (point.get_supernode () == nullptr)
+    return;
 
-	if (point.get_from_edge ())
-	  {
-	    impl_region_model_context ctxt (*this, node,
-					    &state, &next_state,
-					    &uncertainty, nullptr, nullptr);
-	    const cfg_superedge *last_cfg_superedge
-	      = point.get_from_edge ()->dyn_cast_cfg_superedge ();
-	    if (last_cfg_superedge)
-	      next_state.m_region_model->update_for_phis
-		(node->get_supernode (),
-		 last_cfg_superedge,
-		 &ctxt);
-	    program_state::detect_leaks (state, next_state, nullptr,
-					 get_ext_state (), &ctxt);
-	  }
+  /* Specialcase for EXIT BBs, which don't have out-edges.  */
+  if (point.get_supernode ()->exit_p ())
+    {
+      gcc_assert (point.get_supernode ()->m_succs.length () == 0);
 
-	program_point next_point (point.get_next ());
-	exploded_node *next = get_or_create_node (next_point, next_state, node);
-	if (next)
-	  add_edge (node, next, nullptr,
-		    false); /* Assume no work is done at phi nodes.  */
-      }
-      break;
-    case PK_BEFORE_STMT:
-      {
-	/* Determine the effect of a run of one or more statements
-	   within one supernode, generating an edge to the program_point
-	   after the last statement that's processed.
-
-	   Stop iterating statements and thus consolidating into one enode
-	   when:
-	   - reaching the end of the statements in the supernode
-	   - if an sm-state-change occurs (so that it gets its own
-	     exploded_node)
-	   - if "-fanalyzer-fine-grained" is active
-	   - encountering certain statements must appear at the start of
-	   their enode (for which stmt_requires_new_enode_p returns true)
-
-	   Update next_state in-place, to get the result of the one
-	   or more stmts that are processed.
-
-	   Split the node in-place if an sm-state-change occurs, so that
-	   the sm-state-change occurs on an edge where the src enode has
-	   exactly one stmt, the one that caused the change. */
-	program_state next_state (state);
-
-	impl_path_context path_ctxt (&next_state, logger);
-
-	bool could_have_done_work = false;
-	uncertainty_t uncertainty;
-	const supernode *snode = point.get_supernode ();
-	unsigned stmt_idx;
-	const gimple *prev_stmt = nullptr;
-	for (stmt_idx = point.get_stmt_idx ();
-	     stmt_idx < snode->m_stmts.length ();
-	     stmt_idx++)
-	  {
-	    const gimple *stmt = snode->m_stmts[stmt_idx];
+      if (point.get_stack_depth () > 1)
+	{
+	  /* Interprocedural return.  */
+	  auto &src_call_string = point.get_call_string ();
+
+	  const call_string::element_t &top_of_stack
+	    = src_call_string.get_top_of_stack ();
+	  const call_string *dst_call_string = src_call_string.get_parent ();
+	  const program_point dst_point
+	    (top_of_stack.get_return_snode_in_caller (),
+	     *dst_call_string);
+	  auto edge_info
+	    = std::make_unique<interprocedural_return> (top_of_stack.get_call_stmt ());
+
+	  const program_state &src_state (node->get_state ());
+	  program_state dst_state (src_state);
+	  uncertainty_t uncertainty;
+	  impl_region_model_context ctxt (*this, node,
+					  &src_state, &dst_state, &uncertainty,
+					  nullptr,
+					  nullptr);
+	  edge_info->update_state (&dst_state, nullptr, &ctxt);
+
+	  program_state::detect_leaks (src_state, dst_state,
+				       nullptr, get_ext_state (),
+				       &ctxt);
+
+	  if (exploded_node *next
+	      = get_or_create_node (dst_point, dst_state, node))
+	    add_edge (node, next, nullptr, false,
+		      std::move (edge_info));
+	}
+      else
+	{
+	  /* End of top-level of analysis for this function.
+	     Detect leaks, and potentially create a function summary.  */
+	  node->detect_leaks (*this);
 
-	    if (stmt_idx > point.get_stmt_idx ())
-	      if (stmt_requires_new_enode_p (stmt, prev_stmt))
+	  if (flag_analyzer_call_summaries
+	      && point.get_call_string ().empty_p ())
+	    {
+	      /* TODO: create function summary
+		 There can be more than one; each corresponds to a different
+		 final enode in the function.  */
+	      if (logger)
 		{
-		  stmt_idx--;
-		  break;
+		  pretty_printer *pp = logger->get_printer ();
+		  logger->start_log_line ();
+		  logger->log_partial
+		    ("would create function summary for %qE; state: ",
+		     point.get_fndecl ());
+		  state.dump_to_pp (m_ext_state, true, false, pp);
+		  logger->end_log_line ();
 		}
-	    prev_stmt = stmt;
-
-	    program_state old_state (next_state);
-
-	    /* Process the stmt.  */
-	    exploded_node::on_stmt_flags flags
-	      = node->on_stmt (*this, snode, stmt, &next_state, &uncertainty,
-			       &could_have_done_work, &path_ctxt);
-	    node->m_num_processed_stmts++;
-
-	    /* If flags.m_terminate_path, stop analyzing; any nodes/edges
-	       will have been added by on_stmt (e.g. for handling longjmp).  */
-	    if (flags.m_terminate_path)
-	      return;
-
-	    if (next_state.m_region_model)
-	      {
-		impl_region_model_context ctxt (*this, node,
-						&old_state, &next_state,
-						&uncertainty, nullptr, stmt);
-		program_state::detect_leaks (old_state, next_state, nullptr,
-					     get_ext_state (), &ctxt);
-	      }
-
-	    unsigned next_idx = stmt_idx + 1;
-	    program_point next_point
-	      = (next_idx < point.get_supernode ()->m_stmts.length ()
-		 ? program_point::before_stmt (point.get_supernode (), next_idx,
-					       point.get_call_string ())
-		 : program_point::after_supernode (point.get_supernode (),
-						   point.get_call_string ()));
-	    next_state = next_state.prune_for_point (*this, next_point, node,
-						     &uncertainty);
-
-	    if (flag_analyzer_fine_grained
-		|| state_change_requires_new_enode_p (old_state, next_state)
-		|| path_ctxt.bifurcation_p ()
-		|| path_ctxt.terminate_path_p ())
-	      {
-		program_point split_point
-		  = program_point::before_stmt (point.get_supernode (),
-						stmt_idx,
-						point.get_call_string ());
-		if (split_point != node->get_point ())
-		  {
-		    /* If we're not at the start of NODE, split the enode at
-		       this stmt, so we have:
-			 node -> split_enode
-		       so that when split_enode is processed the next edge
-		       we add will be:
-			 split_enode -> next
-		       and any state change will effectively occur on that
-		       latter edge, and split_enode will contain just stmt.  */
-		    if (logger)
-		      logger->log ("getting split_enode");
-		    exploded_node *split_enode
-		      = get_or_create_node (split_point, old_state, node);
-		    if (!split_enode)
-		      return;
-		    /* "stmt" will be reprocessed when split_enode is
-		       processed.  */
-		    node->m_num_processed_stmts--;
-		    if (logger)
-		      logger->log ("creating edge to split_enode");
-		    add_edge (node, split_enode, nullptr, could_have_done_work);
-		    return;
-		  }
-		else
-		  /* If we're at the start of NODE, stop iterating,
-		     so that an edge will be created from NODE to
-		     (next_point, next_state) below. */
-		  break;
-	      }
-	  }
-	unsigned next_idx = stmt_idx + 1;
-	program_point next_point
-	  = (next_idx < point.get_supernode ()->m_stmts.length ()
-	     ? program_point::before_stmt (point.get_supernode (), next_idx,
-					   point.get_call_string ())
-	     : program_point::after_supernode (point.get_supernode (),
-					       point.get_call_string ()));
-	if (path_ctxt.terminate_path_p ())
-	  {
-	    if (logger)
-	      logger->log ("not adding node: terminating path");
-	  }
-	else
-	  {
-	    exploded_node *next
-	      = get_or_create_node (next_point, next_state, node);
-	    if (next)
-	      add_edge (node, next, nullptr, could_have_done_work);
-	  }
-
-	/* If we have custom edge infos, "bifurcate" the state
-	   accordingly, potentially creating a new state/enode/eedge
-	   instances.  For example, to handle a "realloc" call, we
-	   might split into 3 states, for the "failure",
-	   "resizing in place", and "moving to a new buffer" cases.  */
-	for (auto edge_info_iter : path_ctxt.get_custom_eedge_infos ())
-	  {
-	    /* Take ownership of the edge infos from the path_ctxt.  */
-	    std::unique_ptr<custom_edge_info> edge_info (edge_info_iter);
-	    if (logger)
-	      {
-		logger->start_log_line ();
-		logger->log_partial ("bifurcating for edge: ");
-		edge_info->print (logger->get_printer ());
-		logger->end_log_line ();
-	      }
-	    program_state bifurcated_new_state
-	      (path_ctxt.get_state_at_bifurcation ());
-
-	    /* Apply edge_info to state.  */
-	    impl_region_model_context
-	      bifurcation_ctxt (*this,
-				node, // enode_for_diag
-				&path_ctxt.get_state_at_bifurcation (),
-				&bifurcated_new_state,
-				nullptr, // uncertainty_t *uncertainty
-				nullptr, // path_context *path_ctxt
-				stmt);
-	    if (edge_info->update_state (&bifurcated_new_state,
-					 nullptr, /* no exploded_edge yet.  */
-					 &bifurcation_ctxt))
-	      {
-		if (exploded_node *next2
-		    = edge_info->create_enode
-			(*this,
-			 next_point,
-			 std::move (bifurcated_new_state),
-			 node,
-			 &bifurcation_ctxt))
-		  {
-		    add_edge (node, next2, nullptr,
-			      true /* assume that work could be done */,
-			      std::move (edge_info));
-		  }
-	      }
-	    else
-	      {
-		if (logger)
-		  logger->log ("infeasible state, not adding node");
-	      }
-	  }
-      }
-      break;
-    case PK_AFTER_SUPERNODE:
-      {
-	bool found_a_superedge = false;
-	bool is_an_exit_block = false;
-	/* If this is an EXIT BB, detect leaks, and potentially
-	   create a function summary.  */
-	if (point.get_supernode ()->return_p ())
-	  {
-	    is_an_exit_block = true;
-	    node->detect_leaks (*this);
-	    if (flag_analyzer_call_summaries
-		&& point.get_call_string ().empty_p ())
-	      {
-		/* TODO: create function summary
-		   There can be more than one; each corresponds to a different
-		   final enode in the function.  */
-		if (logger)
-		  {
-		    pretty_printer *pp = logger->get_printer ();
-		    logger->start_log_line ();
-		    logger->log_partial
-		      ("would create function summary for %qE; state: ",
-		       point.get_fndecl ());
-		    state.dump_to_pp (m_ext_state, true, false, pp);
-		    logger->end_log_line ();
-		  }
-		per_function_data *per_fn_data
-		  = get_or_create_per_function_data (point.get_function ());
-		per_fn_data->add_call_summary (node);
-	      }
-	  }
-	/* Traverse into successors of the supernode.  */
-	int i;
-	superedge *succ;
-	FOR_EACH_VEC_ELT (point.get_supernode ()->m_succs, i, succ)
-	  {
-	    found_a_superedge = true;
-	    if (logger)
-	      {
-		label_text succ_desc (succ->get_description (false));
-		logger->log ("considering SN: %i -> SN: %i (%s)",
-			     succ->m_src->m_index, succ->m_dest->m_index,
-			     succ_desc.get ());
-	      }
-
-	    program_point next_point
-	      = program_point::before_supernode (succ->m_dest, succ,
-						 point.get_call_string ());
-	    program_state next_state (state);
-	    uncertainty_t uncertainty;
-
-	    /* Make use the current state and try to discover and analyse
-	       indirect function calls (a call that doesn't have an underlying
-	       cgraph edge representing call).
-
-	       Some examples of such calls are virtual function calls
-	       and calls that happen via a function pointer.  */
-	    if (succ->m_kind == SUPEREDGE_INTRAPROCEDURAL_CALL
-		&& !(succ->get_any_callgraph_edge ()))
-	      {
-		const gcall &call
-		  = *point.get_supernode ()->get_final_call ();
-
-		impl_region_model_context ctxt (*this,
-						node,
-						&state,
-						&next_state,
-						&uncertainty,
-						nullptr,
-						point.get_stmt());
-
-		region_model *model = state.m_region_model;
-		bool call_discovered = false;
-
-		if (tree fn_decl = model->get_fndecl_for_call (call, &ctxt))
-		  call_discovered = maybe_create_dynamic_call (call,
-							       fn_decl,
-							       node,
-							       next_state,
-							       next_point,
-							       &uncertainty,
-							       logger);
-		if (!call_discovered)
-		  {
-		    /* Check for jump through nullptr.  */
-		    if (tree fn_ptr = gimple_call_fn (&call))
-		      {
-			const svalue *fn_ptr_sval
-			  = model->get_rvalue (fn_ptr, &ctxt);
-			if (fn_ptr_sval->all_zeroes_p ())
-			  ctxt.warn
-			    (std::make_unique<jump_through_null> (call));
-		      }
-
-		    /* An unknown function or a special function was called
-		       at this point, in such case, don't terminate the
-		       analysis of the current function.
-
-		       The analyzer handles calls to such functions while
-		       analysing the stmt itself, so the function call
-		       must have been handled by the anlyzer till now.  */
-		    exploded_node *next
-		      = get_or_create_node (next_point,
-					    next_state,
-					    node);
-		    if (next)
-		      add_edge (node, next, succ,
-				true /* assume that work is done */);
-		  }
-	      }
+	      per_function_data *per_fn_data
+		= get_or_create_per_function_data (point.get_function ());
+	      per_fn_data->add_call_summary (node);
+	    }
+	}
 
-	    /* Ignore CFG edges in the sgraph flagged with EH whilst
-	       we're exploring the egraph.
-	       We only use these sedges in special-case logic for
-	       dealing with exception-handling.  */
-	    if (auto cfg_sedge = succ->dyn_cast_cfg_superedge ())
-	      if (cfg_sedge->get_flags () & EDGE_EH)
-		{
-		  if (logger)
-		    logger->log ("rejecting EH edge");
-		  continue;
-	      }
+      return;
+    }
 
-	    if (!node->on_edge (*this, succ, &next_point, &next_state,
-				&uncertainty))
-	      {
-		if (logger)
-		  logger->log ("skipping impossible edge to SN: %i",
-			       succ->m_dest->m_index);
-		continue;
-	      }
-	    exploded_node *next = get_or_create_node (next_point, next_state,
-						      node);
-	    if (next)
-	      {
-		add_edge (node, next, succ, false);
+  /* Traverse into successors of the supernode.  */
+  int i;
+  superedge *succ;
+  FOR_EACH_VEC_ELT (point.get_supernode ()->m_succs, i, succ)
+    {
+      if (logger)
+	{
+	  label_text succ_desc (succ->get_description (false));
+	  logger->log ("considering SN: %i -> SN: %i (%s)",
+		       succ->m_src->m_id, succ->m_dest->m_id,
+		       succ_desc.get ());
+	}
 
-		/* We might have a function entrypoint.  */
-		detect_infinite_recursion (next);
-	      }
-	  }
+      program_point next_point (succ->m_dest, point.get_call_string ());
+      program_state next_state (state);
+      uncertainty_t uncertainty;
 
-	/* Return from the calls which doesn't have a return superedge.
-	   Such case occurs when GCC's middle end didn't knew which function to
-	   call but analyzer did.  */
-	if ((is_an_exit_block && !found_a_superedge)
-	    && (!point.get_call_string ().empty_p ()))
-	  {
-	    const call_string &cs = point.get_call_string ();
-	    program_point next_point
-	      = program_point::before_supernode (cs.get_caller_node (),
-						 nullptr,
-						 cs);
-	    program_state next_state (state);
-	    uncertainty_t uncertainty;
-
-	    const gcall *call
-	      = next_point.get_supernode ()->get_returning_call ();
+      /* Find the outcome(s) of any operation on the edge.  */
+      operation_context op_ctxt (*this, *node, *succ);
 
-	    if (call)
-	      next_state.returning_call (*this, node, *call, &uncertainty);
+      /* Skip EH edges.  */
+      if (auto cfg_edge = succ->get_any_cfg_edge ())
+	if (cfg_edge->flags & EDGE_EH)
+	  continue;
 
-	    if (next_state.m_valid)
-	      {
-		next_point.pop_from_call_stack ();
-		exploded_node *enode = get_or_create_node (next_point,
-							   next_state,
-							   node);
-		if (enode)
-		  add_edge (node, enode, nullptr, false,
-			    std::make_unique<dynamic_call_info_t> (*call, true));
-	      }
-	  }
-      }
-      break;
+      if (auto op = succ->get_op ())
+	op->execute (op_ctxt);
+      else
+	{
+	  /* No-op.
+	     Unconditional goto to the dst point, which
+	     must be in same function.
+	     The supernode changes, but the callstring and
+	     state do not change.  */
+	  if (logger)
+	    logger->log ("handling no-op edge");
+	  auto dst_point (op_ctxt.get_next_intraprocedural_point ());
+	  if (exploded_node *next
+	      = get_or_create_node (dst_point,
+				    node->get_state (),
+				    node))
+	    add_edge (node, next, succ, false);
+	}
     }
 }
 
@@ -4830,6 +3797,7 @@ exploded_graph::get_or_create_function_stats (function *fn)
     return *slot;
   else
     {
+      // FIXME:
       int num_supernodes = fn ? n_basic_blocks_for_fn (fn) : 0;
       /* not quite the num supernodes, but nearly.  */
       stats *new_stats = new stats (num_supernodes);
@@ -4864,8 +3832,8 @@ exploded_graph::print_bar_charts (pretty_printer *pp) const
   enodes_per_function.print (pp);
 
   /* Accumulate number of enodes per supernode.  */
-  auto_vec<unsigned> enodes_per_supernode (m_sg.num_nodes ());
-  for (int i = 0; i < m_sg.num_nodes (); i++)
+  auto_vec<unsigned> enodes_per_supernode (m_sg.m_nodes.length ());
+  for (int i = 0; i < m_sg.m_nodes.length (); i++)
     enodes_per_supernode.quick_push (0);
   int i;
   exploded_node *enode;
@@ -4874,12 +3842,12 @@ exploded_graph::print_bar_charts (pretty_printer *pp) const
       const supernode *iter_snode = enode->get_supernode ();
       if (!iter_snode)
 	continue;
-      enodes_per_supernode[iter_snode->m_index]++;
+      enodes_per_supernode[iter_snode->m_id]++;
     }
 
   /* Accumulate excess enodes per supernode.  */
-  auto_vec<unsigned> excess_enodes_per_supernode (m_sg.num_nodes ());
-  for (int i = 0; i < m_sg.num_nodes (); i++)
+  auto_vec<unsigned> excess_enodes_per_supernode (m_sg.m_nodes.length ());
+  for (int i = 0; i < m_sg.m_nodes.length (); i++)
     excess_enodes_per_supernode.quick_push (0);
   for (point_map_t::iterator iter = m_per_point_data.begin ();
        iter != m_per_point_data.end (); ++iter)
@@ -4889,7 +3857,7 @@ exploded_graph::print_bar_charts (pretty_printer *pp) const
       if (!iter_snode)
 	continue;
       const per_program_point_data *point_data = (*iter).second;
-      excess_enodes_per_supernode[iter_snode->m_index]
+      excess_enodes_per_supernode[iter_snode->m_id]
 	+= point_data->m_excess_enodes;
     }
 
@@ -4905,18 +3873,18 @@ exploded_graph::print_bar_charts (pretty_printer *pp) const
       bar_chart enodes_per_snode;
       bar_chart excess_enodes_per_snode;
       bool have_excess_enodes = false;
-      for (int i = 0; i < m_sg.num_nodes (); i++)
+      for (int i = 0; i < m_sg.m_nodes.length (); i++)
 	{
-	  const supernode *iter_snode = m_sg.get_node_by_index (i);
+	  const supernode *iter_snode = m_sg.m_nodes[i];
 	  if (iter_snode->get_function () != fn)
 	    continue;
 	  pretty_printer tmp_pp;
 	  pp_printf (&tmp_pp, "sn %i (bb %i)",
-		     iter_snode->m_index, iter_snode->m_bb->index);
+		     iter_snode->m_id, iter_snode->m_bb->index);
 	  enodes_per_snode.add_item (pp_formatted_text (&tmp_pp),
-				     enodes_per_supernode[iter_snode->m_index]);
+				     enodes_per_supernode[iter_snode->m_id]);
 	  const int num_excess
-	    = excess_enodes_per_supernode[iter_snode->m_index];
+	    = excess_enodes_per_supernode[iter_snode->m_id];
 	  excess_enodes_per_snode.add_item (pp_formatted_text (&tmp_pp),
 					    num_excess);
 	  if (num_excess)
@@ -4945,6 +3913,9 @@ exploded_graph::log_stats () const
 
   m_ext_state.get_engine ()->log_stats (logger);
 
+#if 0
+  logger->log ("m_sg.num_snode_ids (): %i", m_sg.num_snode_ids ());
+#endif
   logger->log ("m_sg.num_nodes (): %i", m_sg.num_nodes ());
   logger->log ("m_nodes.length (): %i", m_nodes.length ());
   logger->log ("m_edges.length (): %i", m_edges.length ());
@@ -4970,6 +3941,9 @@ exploded_graph::log_stats () const
 void
 exploded_graph::dump_stats (FILE *out) const
 {
+#if 0
+  fprintf (out, "m_sg.num_snode_ids (): %i\n", m_sg.num_snode_ids ());
+#endif
   fprintf (out, "m_sg.num_nodes (): %i\n", m_sg.num_nodes ());
   fprintf (out, "m_nodes.length (): %i\n", m_nodes.length ());
   fprintf (out, "m_edges.length (): %i\n", m_edges.length ());
@@ -4986,17 +3960,14 @@ exploded_graph::dump_stats (FILE *out) const
       fprintf (out, "function: %s\n", function_name (fn));
       (*iter).second->dump (out);
     }
-
-  fprintf (out, "PK_AFTER_SUPERNODE per supernode:\n");
-  for (unsigned i = 0; i < m_PK_AFTER_SUPERNODE_per_snode.length (); i++)
-    fprintf (out, "  SN %i: %3i\n", i, m_PK_AFTER_SUPERNODE_per_snode[i]);
 }
 
+#if 0
 void
 exploded_graph::dump_states_for_supernode (FILE *out,
 					   const supernode *snode) const
 {
-  fprintf (out, "PK_AFTER_SUPERNODE nodes for SN: %i\n", snode->m_index);
+  fprintf (out, "PK_AFTER_SUPERNODE nodes for SN: %i\n", snode->m_id);
   int i;
   exploded_node *enode;
   int state_idx = 0;
@@ -5015,8 +3986,9 @@ exploded_graph::dump_states_for_supernode (FILE *out,
 	}
     }
   fprintf (out, "#exploded_node for PK_AFTER_SUPERNODE for SN: %i = %i\n",
-	   snode->m_index, state_idx);
+	   snode->m_id, state_idx);
 }
+#endif
 
 /* Return a new json::object of the form
    {"nodes" : [objs for enodes],
@@ -5061,8 +4033,7 @@ exploded_graph::to_json () const
      stats m_global_stats;
      function_stat_map_t m_per_function_stats;
      stats m_functionless_stats;
-     call_string_data_map_t m_per_call_string_data;
-     auto_vec<int> m_PK_AFTER_SUPERNODE_per_snode;  */
+     call_string_data_map_t m_per_call_string_data;  */
 
   return egraph_obj;
 }
@@ -5080,6 +4051,7 @@ exploded_path::exploded_path (const exploded_path &other)
     m_edges.quick_push (eedge);
 }
 
+
 /* Look for the last use of SEARCH_STMT within this path.
    If found write the edge's index to *OUT_IDX and return true, otherwise
    return false.  */
@@ -5091,19 +4063,32 @@ exploded_path::find_stmt_backwards (const gimple *search_stmt,
   int i;
   const exploded_edge *eedge;
   FOR_EACH_VEC_ELT_REVERSE (m_edges, i, eedge)
-    {
-      const exploded_node *dst_node = eedge->m_dest;
-      const program_point &dst_point = dst_node->get_point ();
-      const gimple *stmt = dst_point.get_stmt ();
-      if (stmt == search_stmt)
-	{
-	  *out_idx = i;
-	  return true;
-	}
-    }
+    if (search_stmt->code == GIMPLE_PHI)
+      {
+	/* Each phis_for_edge_op instance handles multiple phi stmts
+	   at once, so we have to special-case the search for a phi stmt.  */
+	if (auto op = eedge->maybe_get_op ())
+	  if (auto phis_op = op->dyn_cast_phis_for_edge_op ())
+	    if (phis_op->defines_ssa_name_p (gimple_phi_result (search_stmt)))
+	      {
+		*out_idx = i;
+		return true;
+	      }
+      }
+    else
+      {
+	/* Non-phi stmt.  */
+	if (const gimple *stmt = eedge->maybe_get_stmt ())
+	  if (stmt == search_stmt)
+	    {
+	      *out_idx = i;
+	      return true;
+	    }
+      }
   return false;
 }
 
+
 /* Get the final exploded_node in this path, which must be non-empty.  */
 
 exploded_node *
@@ -5145,10 +4130,7 @@ exploded_path::feasible_p (logger *logger,
 	    {
 	      const exploded_node &src_enode = *eedge->m_src;
 	      const program_point &src_point = src_enode.get_point ();
-	      const gimple *last_stmt
-		= src_point.get_supernode ()->get_last_stmt ();
 	      *out = std::make_unique<feasibility_problem> (edge_idx, *eedge,
-							    last_stmt,
 							    std::move (rc));
 	    }
 	  return false;
@@ -5293,108 +4275,76 @@ maybe_update_for_edge (logger *logger,
 		       const exploded_edge *eedge,
 		       region_model_context *ctxt,
 		       std::unique_ptr<rejected_constraint> *out_rc)
-{
-  const exploded_node &src_enode = *eedge->m_src;
-  const program_point &src_point = src_enode.get_point ();
-  if (logger)
-    {
-      logger->start_log_line ();
-      src_point.print (logger->get_printer (), format (false));
-      logger->end_log_line ();
-    }
-
-  /* Update state for the stmts that were processed in each enode.  */
-  for (unsigned stmt_idx = 0; stmt_idx < src_enode.m_num_processed_stmts;
-       stmt_idx++)
-    {
-      const gimple *stmt = src_enode.get_processed_stmt (stmt_idx);
-
-      /* Update cfun and input_location in case of ICE: make it easier to
-	 track down which source construct we're failing to handle.  */
-      auto_cfun sentinel (src_point.get_function ());
-      input_location = stmt->location;
-
-      update_for_stmt (stmt);
-    }
-
-  const superedge *sedge = eedge->m_sedge;
-  if (sedge)
-    {
-      if (logger)
-	{
-	  label_text desc (sedge->get_description (false));
-	  logger->log ("  sedge: SN:%i -> SN:%i %s",
-		       sedge->m_src->m_index,
-		       sedge->m_dest->m_index,
-		       desc.get ());
-	}
-
-      const gimple *last_stmt = src_point.get_supernode ()->get_last_stmt ();
-      if (!m_model.maybe_update_for_edge (*sedge, last_stmt, ctxt, out_rc))
-	{
-	  if (logger)
-	    {
-	      logger->start_log_line ();
-	      logger->log_partial ("rejecting due to region model: ");
-	      m_model.dump_to_pp (logger->get_printer (), true, false);
-	      logger->end_log_line ();
-	    }
-	  return false;
-	}
+{
+  const exploded_node &src_enode = *eedge->m_src;
+  const program_point &src_point = src_enode.get_point ();
+  if (logger)
+    {
+      logger->start_log_line ();
+      src_point.print (logger->get_printer (), format (false));
+      logger->end_log_line ();
     }
+
+  if (eedge->m_custom_info)
+    eedge->m_custom_info->update_model (&m_model, eedge, ctxt);
   else
     {
-      /* Special-case the initial eedge from the origin node to the
-	 initial function by pushing a frame for it.  */
-      if (src_point.get_kind () == PK_ORIGIN)
+      const superedge *sedge = eedge->m_sedge;
+      if (sedge)
 	{
-	  gcc_assert (eedge->m_src->m_index == 0);
-	  gcc_assert (eedge->m_dest->get_point ().get_kind ()
-		      == PK_BEFORE_SUPERNODE);
-	  function *fun = eedge->m_dest->get_function ();
-	  gcc_assert (fun);
-	  m_model.push_frame (*fun, nullptr, nullptr, ctxt);
 	  if (logger)
-	    logger->log ("  pushing frame for %qD", fun->decl);
+	    {
+	      label_text desc (sedge->get_description (false));
+	      logger->log ("  sedge: SN:%i -> SN:%i %s",
+			   sedge->m_src->m_id,
+			   sedge->m_dest->m_id,
+			   desc.get ());
+	    }
+
+	  if (sedge->get_op ())
+	    if (!sedge->get_op ()->execute_for_feasibility (*eedge,
+							    *this,
+							    ctxt,
+							    out_rc))
+	      {
+		if (logger)
+		  {
+		    logger->start_log_line ();
+		    logger->log_partial ("rejecting due to region model: ");
+		    m_model.dump_to_pp (logger->get_printer (), true, false);
+		    logger->end_log_line ();
+		  }
+		return false;
+	      }
 	}
-      else if (eedge->m_custom_info)
+      else
 	{
-	  eedge->m_custom_info->update_model (&m_model, eedge, ctxt);
+	  /* Special-case the initial eedge from the origin node to the
+	     initial function by pushing a frame for it.  */
+	  if (eedge->m_src->m_index == 0)
+	    {
+	      function *fun = eedge->m_dest->get_function ();
+	      gcc_assert (fun);
+	      m_model.push_frame (*fun, nullptr, nullptr, ctxt);
+	      if (logger)
+		logger->log ("  pushing frame for %qD", fun->decl);
+	    }
 	}
     }
 
-  /* Handle phi nodes on an edge leaving a PK_BEFORE_SUPERNODE (to
-     a PK_BEFORE_STMT, or a PK_AFTER_SUPERNODE if no stmts).
-     This will typically not be associated with a superedge.  */
-  if (src_point.get_from_edge ())
-    {
-      const cfg_superedge *last_cfg_superedge
-	= src_point.get_from_edge ()->dyn_cast_cfg_superedge ();
-      const exploded_node &dst_enode = *eedge->m_dest;
-      const unsigned dst_snode_idx = dst_enode.get_supernode ()->m_index;
-      if (last_cfg_superedge)
-	{
-	  if (logger)
-	    logger->log ("  update for phis");
-	  m_model.update_for_phis (src_enode.get_supernode (),
-				  last_cfg_superedge,
-				  ctxt);
-	  /* If we've entering an snode that we've already visited on this
-	     epath, then we need do fix things up for loops; see the
-	     comment for store::loop_replay_fixup.
-	     Perhaps we should probably also verify the callstring,
-	     and track program_points,  but hopefully doing it by supernode
-	     is good enough.  */
-	  if (bitmap_bit_p (m_snodes_visited, dst_snode_idx))
-	    m_model.loop_replay_fixup (dst_enode.get_state ().m_region_model);
-	}
-      bitmap_set_bit (m_snodes_visited, dst_snode_idx);
-    }
+
+  {
+    const exploded_node &dst_enode = *eedge->m_dest;
+    const unsigned dst_snode_idx = dst_enode.get_supernode ()->m_id;
+    bitmap_set_bit (m_snodes_visited, dst_snode_idx);
+  }
+
   return true;
 }
 
 /* Update this object for the effects of STMT.  */
 
+#if 0
 void
 feasibility_state::update_for_stmt (const gimple *stmt)
 {
@@ -5410,6 +4360,7 @@ feasibility_state::update_for_stmt (const gimple *stmt)
   else if (const greturn *return_ = dyn_cast <const greturn *> (stmt))
     m_model.on_return (return_, nullptr);
 }
+#endif
 
 /* Dump this object to PP.  */
 
@@ -5451,11 +4402,11 @@ public:
 
   void dump_dot (graphviz_out *gv, const dump_args_t &args) const final override
   {
-    gv->println ("subgraph \"cluster_supernode_%i\" {", m_supernode->m_index);
+    gv->println ("subgraph \"cluster_supernode_%i\" {", m_supernode->m_id);
     gv->indent ();
     gv->println ("style=\"dashed\";");
     gv->println ("label=\"SN: %i (bb: %i; scc: %i)\";",
-		 m_supernode->m_index, m_supernode->m_bb->index,
+		 m_supernode->m_id, m_supernode->m_bb->index,
 		 args.m_eg.get_scc_id (*m_supernode));
 
     int i;
@@ -5481,7 +4432,7 @@ public:
       = *(const supernode_cluster * const *)p1;
     const supernode_cluster *c2
       = *(const supernode_cluster * const *)p2;
-    return c1->m_supernode->m_index - c2->m_supernode->m_index;
+    return c1->m_supernode->m_id - c2->m_supernode->m_id;
   }
 
 private:
@@ -5755,7 +4706,6 @@ exploded_graph::dump_exploded_nodes () const
   /* Alternatively, simply throw them all into one big rich_location
      and see if the label-printing will sort it out...
      This requires them all to be in the same source file.  */
-
   if (flag_dump_analyzer_exploded_nodes)
     {
       auto_timevar tv (TV_ANALYZER_DUMP);
@@ -5764,15 +4714,13 @@ exploded_graph::dump_exploded_nodes () const
       exploded_node *enode;
       FOR_EACH_VEC_ELT (m_nodes, i, enode)
 	{
-	  if (const gimple *stmt = enode->get_stmt ())
-	    {
-	      if (get_pure_location (richloc.get_loc ()) == UNKNOWN_LOCATION)
-		richloc.set_range (0, stmt->location, SHOW_RANGE_WITH_CARET);
-	      else
-		richloc.add_range (stmt->location,
-				   SHOW_RANGE_WITHOUT_CARET,
-				   new enode_label (m_ext_state, enode));
-	    }
+	  location_t loc = enode->get_location ();
+	  if (get_pure_location (richloc.get_loc ()) == UNKNOWN_LOCATION)
+	    richloc.set_range (0, loc, SHOW_RANGE_WITH_CARET);
+	  else
+	    richloc.add_range (loc,
+			       SHOW_RANGE_WITHOUT_CARET,
+			       new enode_label (m_ext_state, enode));
 	}
       warning_at (&richloc, 0, "%i exploded nodes", m_nodes.length ());
 
